Bug 622024 - 64-bit kernel unable to oprofile 32-bit processes
Summary: 64-bit kernel unable to oprofile 32-bit processes
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel   
(Show other bugs)
Version: 5.5
Hardware: x86_64
OS: Linux
low
medium
Target Milestone: rc
: ---
Assignee: Jiri Olsa
QA Contact: Chao Ye
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2010-08-06 19:25 UTC by Tom Marshall
Modified: 2011-01-13 21:09 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-01-13 21:09:29 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Add logic to backtrace ia32 processes in x86_64 kernel (1.44 KB, patch)
2010-08-06 19:25 UTC, Tom Marshall
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2011:0017 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 5.6 kernel security and bug fix update 2011-01-13 10:37:42 UTC

Description Tom Marshall 2010-08-06 19:25:49 UTC
Created attachment 437244 [details]
Add logic to backtrace ia32 processes in x86_64 kernel

Description of problem:

The oprofile kernel module, when compiled under x86_64, is unable to obtain a proper backtrace on ia32 userspace processes because it lacks the logic to do so.

Please find the attached patch to add this logic.

Comment 1 Jiri Olsa 2010-09-13 18:09:45 UTC
hi,

I sent the patch upstream
http://lkml.org/lkml/2010/9/13/169

backported RHEL5 kernel could be downloaded here:
http://people.redhat.com/jolsa/622024/

will send it to review, once accepted upstream.
Any test results appreciated ;)

thanks,
jirka

Comment 2 Tom Marshall 2010-09-20 22:25:13 UTC
Upstream had some comments and the patch seems to be dropped.  Some of the comments are specific to the later kernel (stack_frame_ia32 does not seem to exist in 2.6.18) and some are not (prefer CONFIG_COMPAT over CONFIG_X86_64).

If upstream acceptance is a prerequisite to inclusion in RHEL, please advise whether you would like to fix and resubmit or whether you would like me to resubmit.

Thanks!

Comment 3 Jiri Olsa 2010-09-21 07:51:01 UTC
(In reply to comment #2)
> Upstream had some comments and the patch seems to be dropped.  Some of the
> comments are specific to the later kernel (stack_frame_ia32 does not seem to
> exist in 2.6.18) and some are not (prefer CONFIG_COMPAT over CONFIG_X86_64).
> 
> If upstream acceptance is a prerequisite to inclusion in RHEL, please advise
> whether you would like to fix and resubmit or whether you would like me to
> resubmit.

The upstream acceptance is crucial.. and I guess you are more oprofile 
experienced.. if you can resubmit the patch for upstream, it'd be big help.
Feel free to directly answer the upstream conversation.

thanks,
jirka

Comment 4 Tom Marshall 2010-09-21 17:37:33 UTC
Actually, I'm not an oprofile user, I'm just the RHEL maintainer and "Linux guy" here.  :)  But I'll respin the patch and toss it back out to lkml.

Once this gets accepted, will it automagically be included in RHEL 6?  If not, what is the procedure to ensure that happens?

Comment 5 Jiri Olsa 2010-09-22 11:12:30 UTC
I can send out the patch for RHEL6 as well, np

thanks,
jirka

Comment 6 Jiri Olsa 2010-09-29 11:01:56 UTC
hi,
any update on the upstream patch?

thanks,
jirka

Comment 7 Jiri Olsa 2010-09-29 15:05:59 UTC
I sent new version upstream:
http://marc.info/?l=linux-kernel&m=128577164225720&w=2

jirka

Comment 9 RHEL Product and Program Management 2010-10-04 16:30:31 UTC
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.

Comment 10 Tom Marshall 2010-10-05 21:01:34 UTC
Thanks Jiri!

Comment 12 Jarod Wilson 2010-10-14 14:02:53 UTC
in kernel-2.6.18-227.el5
You can download this test kernel (or newer) from http://people.redhat.com/jwilson/el5

Detailed testing feedback is always welcomed.

Comment 14 Chao Ye 2010-12-16 09:10:08 UTC
Confirmed that oprofile-0.9.6 can be compiled under kernel-2.6.18-221.el5.x86_64

Comment 16 errata-xmlrpc 2011-01-13 21:09:29 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2011-0017.html


Note You need to log in before you can comment on or make changes to this bug.